<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvoiceDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInvoiceDetail
 * @subpackage Arrays
 */
class ArrayOfInvoiceDetail extends AbstractStructArrayBase
{
    /**
     * The InvoiceDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InvoiceDetail[]
     */
    public $InvoiceDetail;
    /**
     * Constructor method for ArrayOfInvoiceDetail
     * @uses ArrayOfInvoiceDetail::setInvoiceDetail()
     * @param \StructType\InvoiceDetail[] $invoiceDetail
     */
    public function __construct(array $invoiceDetail = array())
    {
        $this
            ->setInvoiceDetail($invoiceDetail);
    }
    /**
     * Get InvoiceDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InvoiceDetail[]|null
     */
    public function getInvoiceDetail()
    {
        return isset($this->InvoiceDetail) ? $this->InvoiceDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInvoiceDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvoiceDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvoiceDetailForArrayConstraintsFromSetInvoiceDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvoiceDetailInvoiceDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvoiceDetailInvoiceDetailItem instanceof \StructType\InvoiceDetail) {
                $invalidValues[] = is_object($arrayOfInvoiceDetailInvoiceDetailItem) ? get_class($arrayOfInvoiceDetailInvoiceDetailItem) : sprintf('%s(%s)', gettype($arrayOfInvoiceDetailInvoiceDetailItem), var_export($arrayOfInvoiceDetailInvoiceDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvoiceDetail property can only contain items of type \StructType\InvoiceDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvoiceDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceDetail[] $invoiceDetail
     * @return \ArrayType\ArrayOfInvoiceDetail
     */
    public function setInvoiceDetail(array $invoiceDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($invoiceDetailArrayErrorMessage = self::validateInvoiceDetailForArrayConstraintsFromSetInvoiceDetail($invoiceDetail))) {
            throw new \InvalidArgumentException($invoiceDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($invoiceDetail) || (is_array($invoiceDetail) && empty($invoiceDetail))) {
            unset($this->InvoiceDetail);
        } else {
            $this->InvoiceDetail = $invoiceDetail;
        }
        return $this;
    }
    /**
     * Add item to InvoiceDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\InvoiceDetail $item
     * @return \ArrayType\ArrayOfInvoiceDetail
     */
    public function addToInvoiceDetail(\StructType\InvoiceDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvoiceDetail) {
            throw new \InvalidArgumentException(sprintf('The InvoiceDetail property can only contain items of type \StructType\InvoiceDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvoiceDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InvoiceDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InvoiceDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InvoiceDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InvoiceDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InvoiceDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InvoiceDetail
     */
    public function getAttributeName()
    {
        return 'InvoiceDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfInvoiceDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
