<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLoginDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLoginDetail
 * @subpackage Arrays
 */
class ArrayOfLoginDetail extends AbstractStructArrayBase
{
    /**
     * The LoginDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LoginDetail[]
     */
    public $LoginDetail;
    /**
     * Constructor method for ArrayOfLoginDetail
     * @uses ArrayOfLoginDetail::setLoginDetail()
     * @param \StructType\LoginDetail[] $loginDetail
     */
    public function __construct(array $loginDetail = array())
    {
        $this
            ->setLoginDetail($loginDetail);
    }
    /**
     * Get LoginDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LoginDetail[]|null
     */
    public function getLoginDetail()
    {
        return isset($this->LoginDetail) ? $this->LoginDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setLoginDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLoginDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLoginDetailForArrayConstraintsFromSetLoginDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfLoginDetailLoginDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfLoginDetailLoginDetailItem instanceof \StructType\LoginDetail) {
                $invalidValues[] = is_object($arrayOfLoginDetailLoginDetailItem) ? get_class($arrayOfLoginDetailLoginDetailItem) : sprintf('%s(%s)', gettype($arrayOfLoginDetailLoginDetailItem), var_export($arrayOfLoginDetailLoginDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LoginDetail property can only contain items of type \StructType\LoginDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LoginDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LoginDetail[] $loginDetail
     * @return \ArrayType\ArrayOfLoginDetail
     */
    public function setLoginDetail(array $loginDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($loginDetailArrayErrorMessage = self::validateLoginDetailForArrayConstraintsFromSetLoginDetail($loginDetail))) {
            throw new \InvalidArgumentException($loginDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($loginDetail) || (is_array($loginDetail) && empty($loginDetail))) {
            unset($this->LoginDetail);
        } else {
            $this->LoginDetail = $loginDetail;
        }
        return $this;
    }
    /**
     * Add item to LoginDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\LoginDetail $item
     * @return \ArrayType\ArrayOfLoginDetail
     */
    public function addToLoginDetail(\StructType\LoginDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LoginDetail) {
            throw new \InvalidArgumentException(sprintf('The LoginDetail property can only contain items of type \StructType\LoginDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LoginDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LoginDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LoginDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LoginDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LoginDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LoginDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LoginDetail
     */
    public function getAttributeName()
    {
        return 'LoginDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLoginDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
