<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ServiceCredential' => '\\StructType\\ServiceCredential',
            'ArrayOfLoginDetail' => '\\ArrayType\\ArrayOfLoginDetail',
            'LoginDetail' => '\\StructType\\LoginDetail',
            'ArrayOfMemberPackage' => '\\ArrayType\\ArrayOfMemberPackage',
            'MemberPackage' => '\\StructType\\MemberPackage',
            'ArrayOfMemberAddress' => '\\ArrayType\\ArrayOfMemberAddress',
            'MemberAddress' => '\\StructType\\MemberAddress',
            'DbActionBase' => '\\StructType\\DbActionBase',
            'ArrayOfMemberContact' => '\\ArrayType\\ArrayOfMemberContact',
            'MemberContact' => '\\StructType\\MemberContact',
            'MemberDirectory' => '\\StructType\\MemberDirectory',
            'Member' => '\\StructType\\Member',
            'SearchCriteria' => '\\StructType\\SearchCriteria',
            'ArrayOfMemberSearch' => '\\ArrayType\\ArrayOfMemberSearch',
            'MemberSearch' => '\\StructType\\MemberSearch',
            'ArrayOfMemberAvailability' => '\\ArrayType\\ArrayOfMemberAvailability',
            'MemberAvailability' => '\\StructType\\MemberAvailability',
            'ReportWork' => '\\StructType\\ReportWork',
            'ArrayOfReportWork' => '\\ArrayType\\ArrayOfReportWork',
            'ArrayOfInvoiceDetail' => '\\ArrayType\\ArrayOfInvoiceDetail',
            'InvoiceDetail' => '\\StructType\\InvoiceDetail',
            'ArrayOfNameValue' => '\\ArrayType\\ArrayOfNameValue',
            'NameValue' => '\\StructType\\NameValue',
            'GetLoginMessage' => '\\StructType\\GetLoginMessage',
            'GetLoginMessageResponse' => '\\StructType\\GetLoginMessageResponse',
            'CreateServiceCredentials' => '\\StructType\\CreateServiceCredentials',
            'CreateServiceCredentialsResponse' => '\\StructType\\CreateServiceCredentialsResponse',
            'RetrieveLogin' => '\\StructType\\RetrieveLogin',
            'RetrieveLoginResponse' => '\\StructType\\RetrieveLoginResponse',
            'RetrieveAllMemberData' => '\\StructType\\RetrieveAllMemberData',
            'RetrieveAllMemberDataResponse' => '\\StructType\\RetrieveAllMemberDataResponse',
            'RetrieveSingleMemberData' => '\\StructType\\RetrieveSingleMemberData',
            'RetrieveSingleMemberDataResponse' => '\\StructType\\RetrieveSingleMemberDataResponse',
            'MemberById' => '\\StructType\\MemberById',
            'MemberByIdResponse' => '\\StructType\\MemberByIdResponse',
            'MemberContactsById' => '\\StructType\\MemberContactsById',
            'MemberContactsByIdResponse' => '\\StructType\\MemberContactsByIdResponse',
            'MemberAddressesById' => '\\StructType\\MemberAddressesById',
            'MemberAddressesByIdResponse' => '\\StructType\\MemberAddressesByIdResponse',
            'MemberSearchFilterAllCriteria' => '\\StructType\\MemberSearchFilterAllCriteria',
            'MemberSearchFilterAllCriteriaResponse' => '\\StructType\\MemberSearchFilterAllCriteriaResponse',
            'MemberDirectorySearch' => '\\StructType\\MemberDirectorySearch',
            'MemberDirectorySearchResponse' => '\\StructType\\MemberDirectorySearchResponse',
            'MemberPasswordUpdate' => '\\StructType\\MemberPasswordUpdate',
            'MemberPasswordUpdateResponse' => '\\StructType\\MemberPasswordUpdateResponse',
            'MemberUpdate' => '\\StructType\\MemberUpdate',
            'MemberUpdateResponse' => '\\StructType\\MemberUpdateResponse',
            'MemberDirectoryDelete' => '\\StructType\\MemberDirectoryDelete',
            'MemberDirectoryDeleteResponse' => '\\StructType\\MemberDirectoryDeleteResponse',
            'MemberDirectoryInsert' => '\\StructType\\MemberDirectoryInsert',
            'MemberDirectoryInsertResponse' => '\\StructType\\MemberDirectoryInsertResponse',
            'MemberDirectoryUpdate' => '\\StructType\\MemberDirectoryUpdate',
            'MemberDirectoryUpdateResponse' => '\\StructType\\MemberDirectoryUpdateResponse',
            'MemberContactDelete' => '\\StructType\\MemberContactDelete',
            'MemberContactDeleteResponse' => '\\StructType\\MemberContactDeleteResponse',
            'MemberContactInsert' => '\\StructType\\MemberContactInsert',
            'MemberContactInsertResponse' => '\\StructType\\MemberContactInsertResponse',
            'MemberContactUpdate' => '\\StructType\\MemberContactUpdate',
            'MemberContactUpdateResponse' => '\\StructType\\MemberContactUpdateResponse',
            'MemberAddressDelete' => '\\StructType\\MemberAddressDelete',
            'MemberAddressDeleteResponse' => '\\StructType\\MemberAddressDeleteResponse',
            'MemberAddressInsert' => '\\StructType\\MemberAddressInsert',
            'MemberAddressInsertResponse' => '\\StructType\\MemberAddressInsertResponse',
            'MemberAddressUpdate' => '\\StructType\\MemberAddressUpdate',
            'MemberAddressUpdateResponse' => '\\StructType\\MemberAddressUpdateResponse',
            'MemberAvailabilityUpdate' => '\\StructType\\MemberAvailabilityUpdate',
            'MemberAvailabilityUpdateResponse' => '\\StructType\\MemberAvailabilityUpdateResponse',
            'RetrieveAllMemberAvailability' => '\\StructType\\RetrieveAllMemberAvailability',
            'RetrieveAllMemberAvailabilityResponse' => '\\StructType\\RetrieveAllMemberAvailabilityResponse',
            'RetrieveSingleMemberAvailability' => '\\StructType\\RetrieveSingleMemberAvailability',
            'RetrieveSingleMemberAvailabilityResponse' => '\\StructType\\RetrieveSingleMemberAvailabilityResponse',
            'ReportWorkInsert' => '\\StructType\\ReportWorkInsert',
            'ReportWorkInsertResponse' => '\\StructType\\ReportWorkInsertResponse',
            'ReportWorkUpdate' => '\\StructType\\ReportWorkUpdate',
            'ReportWorkUpdateResponse' => '\\StructType\\ReportWorkUpdateResponse',
            'ReportWorkDelete' => '\\StructType\\ReportWorkDelete',
            'ReportWorkDeleteResponse' => '\\StructType\\ReportWorkDeleteResponse',
            'ReportWorkByMember' => '\\StructType\\ReportWorkByMember',
            'ReportWorkByMemberResponse' => '\\StructType\\ReportWorkByMemberResponse',
            'InvoiceByMember' => '\\StructType\\InvoiceByMember',
            'InvoiceByMemberResponse' => '\\StructType\\InvoiceByMemberResponse',
            'PaymentTypes' => '\\StructType\\PaymentTypes',
            'PaymentTypesResponse' => '\\StructType\\PaymentTypesResponse',
            'BillingDates' => '\\StructType\\BillingDates',
            'BillingDatesResponse' => '\\StructType\\BillingDatesResponse',
            'AddPayment' => '\\StructType\\AddPayment',
            'AddPaymentResponse' => '\\StructType\\AddPaymentResponse',
            'MemberConfidentialityTypes' => '\\StructType\\MemberConfidentialityTypes',
            'MemberConfidentialityTypesResponse' => '\\StructType\\MemberConfidentialityTypesResponse',
            'MemberDirectoryTypes' => '\\StructType\\MemberDirectoryTypes',
            'MemberDirectoryTypesResponse' => '\\StructType\\MemberDirectoryTypesResponse',
            'MemberCraftTypes' => '\\StructType\\MemberCraftTypes',
            'MemberCraftTypesResponse' => '\\StructType\\MemberCraftTypesResponse',
            'MemberStatusTypes' => '\\StructType\\MemberStatusTypes',
            'MemberStatusTypesResponse' => '\\StructType\\MemberStatusTypesResponse',
            'States' => '\\StructType\\States',
            'StatesResponse' => '\\StructType\\StatesResponse',
            'Countries' => '\\StructType\\Countries',
            'CountriesResponse' => '\\StructType\\CountriesResponse',
            'MemberAddressTypes' => '\\StructType\\MemberAddressTypes',
            'MemberAddressTypesResponse' => '\\StructType\\MemberAddressTypesResponse',
            'Shows' => '\\StructType\\Shows',
            'ShowsResponse' => '\\StructType\\ShowsResponse',
            'Roles' => '\\StructType\\Roles',
            'RolesResponse' => '\\StructType\\RolesResponse',
            'GetSSOToken' => '\\StructType\\GetSSOToken',
            'GetSSOTokenResponse' => '\\StructType\\GetSSOTokenResponse',
            'ValidateSSOToken' => '\\StructType\\ValidateSSOToken',
            'ValidateSSOTokenResponse' => '\\StructType\\ValidateSSOTokenResponse',
        );
    }
}
