<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateServiceCredentials StructType
 * @subpackage Structs
 */
class CreateServiceCredentials extends AbstractStructBase
{
    /**
     * The serviceUserName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $serviceUserName;
    /**
     * The servicePassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $servicePassword;
    /**
     * Constructor method for CreateServiceCredentials
     * @uses CreateServiceCredentials::setServiceUserName()
     * @uses CreateServiceCredentials::setServicePassword()
     * @param string $serviceUserName
     * @param string $servicePassword
     */
    public function __construct($serviceUserName = null, $servicePassword = null)
    {
        $this
            ->setServiceUserName($serviceUserName)
            ->setServicePassword($servicePassword);
    }
    /**
     * Get serviceUserName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServiceUserName()
    {
        return isset($this->serviceUserName) ? $this->serviceUserName : null;
    }
    /**
     * Set serviceUserName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serviceUserName
     * @return \StructType\CreateServiceCredentials
     */
    public function setServiceUserName($serviceUserName = null)
    {
        // validation for constraint: string
        if (!is_null($serviceUserName) && !is_string($serviceUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceUserName, true), gettype($serviceUserName)), __LINE__);
        }
        if (is_null($serviceUserName) || (is_array($serviceUserName) && empty($serviceUserName))) {
            unset($this->serviceUserName);
        } else {
            $this->serviceUserName = $serviceUserName;
        }
        return $this;
    }
    /**
     * Get servicePassword value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServicePassword()
    {
        return isset($this->servicePassword) ? $this->servicePassword : null;
    }
    /**
     * Set servicePassword value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $servicePassword
     * @return \StructType\CreateServiceCredentials
     */
    public function setServicePassword($servicePassword = null)
    {
        // validation for constraint: string
        if (!is_null($servicePassword) && !is_string($servicePassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($servicePassword, true), gettype($servicePassword)), __LINE__);
        }
        if (is_null($servicePassword) || (is_array($servicePassword) && empty($servicePassword))) {
            unset($this->servicePassword);
        } else {
            $this->servicePassword = $servicePassword;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateServiceCredentials
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
