<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReportWorkInsertResponse StructType
 * @subpackage Structs
 */
class ReportWorkInsertResponse extends AbstractStructBase
{
    /**
     * The ReportWorkInsertResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ReportWorkInsertResult;
    /**
     * The returnValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $returnValue;
    /**
     * Constructor method for ReportWorkInsertResponse
     * @uses ReportWorkInsertResponse::setReportWorkInsertResult()
     * @uses ReportWorkInsertResponse::setReturnValue()
     * @param bool $reportWorkInsertResult
     * @param int $returnValue
     */
    public function __construct($reportWorkInsertResult = null, $returnValue = null)
    {
        $this
            ->setReportWorkInsertResult($reportWorkInsertResult)
            ->setReturnValue($returnValue);
    }
    /**
     * Get ReportWorkInsertResult value
     * @return bool|null
     */
    public function getReportWorkInsertResult()
    {
        return $this->ReportWorkInsertResult;
    }
    /**
     * Set ReportWorkInsertResult value
     * @param bool $reportWorkInsertResult
     * @return \StructType\ReportWorkInsertResponse
     */
    public function setReportWorkInsertResult($reportWorkInsertResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($reportWorkInsertResult) && !is_bool($reportWorkInsertResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($reportWorkInsertResult, true), gettype($reportWorkInsertResult)), __LINE__);
        }
        $this->ReportWorkInsertResult = $reportWorkInsertResult;
        return $this;
    }
    /**
     * Get returnValue value
     * @return int|null
     */
    public function getReturnValue()
    {
        return $this->returnValue;
    }
    /**
     * Set returnValue value
     * @param int $returnValue
     * @return \StructType\ReportWorkInsertResponse
     */
    public function setReturnValue($returnValue = null)
    {
        // validation for constraint: int
        if (!is_null($returnValue) && !(is_int($returnValue) || ctype_digit($returnValue))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($returnValue, true), gettype($returnValue)), __LINE__);
        }
        $this->returnValue = $returnValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ReportWorkInsertResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
